# CfnStorageVirtualMachine

Creates a storage virtual machine (SVM) for an Amazon FSx for ONTAP file system.

Extends: [Construct](https://docs.aws.amazon.com/cdk/api/v2/docs/constructs.Construct.html) › [CfnElement](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnElement.html) › [CfnRefElement](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnRefElement.html) › [CfnResource](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnResource.html) › CfnStorageVirtualMachine
Implements: [IInspectable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IInspectable.html), [ITaggable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.ITaggable.html), [IEnvironmentAware](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.IEnvironmentAware.html), IStorageVirtualMachineRef, IConstruct, IDependable

- CloudFormation: [`AWS::FSx::StorageVirtualMachine`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-fsx-storagevirtualmachine.html)
- Source: Generated at build time
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

TypeScript:

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_fsx as fsx } from 'aws-cdk-lib';
const cfnStorageVirtualMachine = new fsx.CfnStorageVirtualMachine(this, 'MyCfnStorageVirtualMachine', {
  fileSystemId: 'fileSystemId',
  name: 'name',

  // the properties below are optional
  activeDirectoryConfiguration: {
    netBiosName: 'netBiosName',
    selfManagedActiveDirectoryConfiguration: {
      dnsIps: ['dnsIps'],
      domainJoinServiceAccountSecret: 'domainJoinServiceAccountSecret',
      domainName: 'domainName',
      fileSystemAdministratorsGroup: 'fileSystemAdministratorsGroup',
      organizationalUnitDistinguishedName: 'organizationalUnitDistinguishedName',
      password: 'password',
      userName: 'userName',
    },
  },
  rootVolumeSecurityStyle: 'rootVolumeSecurityStyle',
  svmAdminPassword: 'svmAdminPassword',
  tags: [{
    key: 'key',
    value: 'value',
  }],
});
```

Python:

```python
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_fsx as fsx

cfn_storage_virtual_machine = fsx.CfnStorageVirtualMachine(self, "MyCfnStorageVirtualMachine",
    file_system_id="fileSystemId",
    name="name",

    # the properties below are optional
    active_directory_configuration=fsx.CfnStorageVirtualMachine.ActiveDirectoryConfigurationProperty(
        net_bios_name="netBiosName",
        self_managed_active_directory_configuration=fsx.CfnStorageVirtualMachine.SelfManagedActiveDirectoryConfigurationProperty(
            dns_ips=["dnsIps"],
            domain_join_service_account_secret="domainJoinServiceAccountSecret",
            domain_name="domainName",
            file_system_administrators_group="fileSystemAdministratorsGroup",
            organizational_unit_distinguished_name="organizationalUnitDistinguishedName",
            password="password",
            user_name="userName"
        )
    ),
    root_volume_security_style="rootVolumeSecurityStyle",
    svm_admin_password="svmAdminPassword",
    tags=[CfnTag(
        key="key",
        value="value"
    )]
)
```

Java:

```java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.fsx.*;

CfnStorageVirtualMachine cfnStorageVirtualMachine = CfnStorageVirtualMachine.Builder.create(this, "MyCfnStorageVirtualMachine")
        .fileSystemId("fileSystemId")
        .name("name")

        // the properties below are optional
        .activeDirectoryConfiguration(ActiveDirectoryConfigurationProperty.builder()
                .netBiosName("netBiosName")
                .selfManagedActiveDirectoryConfiguration(SelfManagedActiveDirectoryConfigurationProperty.builder()
                        .dnsIps(List.of("dnsIps"))
                        .domainJoinServiceAccountSecret("domainJoinServiceAccountSecret")
                        .domainName("domainName")
                        .fileSystemAdministratorsGroup("fileSystemAdministratorsGroup")
                        .organizationalUnitDistinguishedName("organizationalUnitDistinguishedName")
                        .password("password")
                        .userName("userName")
                        .build())
                .build())
        .rootVolumeSecurityStyle("rootVolumeSecurityStyle")
        .svmAdminPassword("svmAdminPassword")
        .tags(List.of(CfnTag.builder()
                .key("key")
                .value("value")
                .build()))
        .build();
```

C# / .NET:

```csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.FSx;

var cfnStorageVirtualMachine = new CfnStorageVirtualMachine(this, "MyCfnStorageVirtualMachine", new CfnStorageVirtualMachineProps {
    FileSystemId = "fileSystemId",
    Name = "name",

    // the properties below are optional
    ActiveDirectoryConfiguration = new ActiveDirectoryConfigurationProperty {
        NetBiosName = "netBiosName",
        SelfManagedActiveDirectoryConfiguration = new SelfManagedActiveDirectoryConfigurationProperty {
            DnsIps = new [] { "dnsIps" },
            DomainJoinServiceAccountSecret = "domainJoinServiceAccountSecret",
            DomainName = "domainName",
            FileSystemAdministratorsGroup = "fileSystemAdministratorsGroup",
            OrganizationalUnitDistinguishedName = "organizationalUnitDistinguishedName",
            Password = "password",
            UserName = "userName"
        }
    },
    RootVolumeSecurityStyle = "rootVolumeSecurityStyle",
    SvmAdminPassword = "svmAdminPassword",
    Tags = new [] { new CfnTag {
        Key = "key",
        Value = "value"
    } }
});
```

Golang:

```go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

cfnStorageVirtualMachine := awscdk.Aws_fsx.NewCfnStorageVirtualMachine(this, jsii.String("MyCfnStorageVirtualMachine"), &CfnStorageVirtualMachineProps{
	FileSystemId: jsii.String("fileSystemId"),
	Name: jsii.String("name"),

	// the properties below are optional
	ActiveDirectoryConfiguration: &ActiveDirectoryConfigurationProperty{
		NetBiosName: jsii.String("netBiosName"),
		SelfManagedActiveDirectoryConfiguration: &SelfManagedActiveDirectoryConfigurationProperty{
			DnsIps: []*string{
				jsii.String("dnsIps"),
			},
			DomainJoinServiceAccountSecret: jsii.String("domainJoinServiceAccountSecret"),
			DomainName: jsii.String("domainName"),
			FileSystemAdministratorsGroup: jsii.String("fileSystemAdministratorsGroup"),
			OrganizationalUnitDistinguishedName: jsii.String("organizationalUnitDistinguishedName"),
			Password: jsii.String("password"),
			UserName: jsii.String("userName"),
		},
	},
	RootVolumeSecurityStyle: jsii.String("rootVolumeSecurityStyle"),
	SvmAdminPassword: jsii.String("svmAdminPassword"),
	Tags: []CfnTag{
		&CfnTag{
			Key: jsii.String("key"),
			Value: jsii.String("value"),
		},
	},
})
```

## Initializer

TypeScript:

```ts
new CfnStorageVirtualMachine(scope: Construct, id: string, props: CfnStorageVirtualMachineProps)
```

Python:

```python
CfnStorageVirtualMachine(scope: Construct, id: str, props: CfnStorageVirtualMachineProps)
```

Java:

```java
new CfnStorageVirtualMachine(Construct scope, String id, CfnStorageVirtualMachineProps props)
```

C# / .NET:

```csharp
new CfnStorageVirtualMachine(Construct scope, string id, CfnStorageVirtualMachineProps props)
```

Golang:

```go
NewCfnStorageVirtualMachine(Scope Construct, Id *string, Props CfnStorageVirtualMachineProps)
```

## Construct Props

- `activeDirectoryConfiguration`: [IResolvable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStorageVirtualMachine.ActiveDirectoryConfigurationProperty](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnStorageVirtualMachine.ActiveDirectoryConfigurationProperty.html) — Describes the Microsoft Active Directory configuration to which the SVM is joined, if applicable.

- `fileSystemId`: string (required) — Specifies the FSx for ONTAP file system on which to create the SVM.

- `name`: string (required) — The name of the SVM.

- `rootVolumeSecurityStyle`: string — The security style of the root volume of the SVM. Specify one of the following values:.

  - `UNIX` if the file system is managed by a UNIX administrator, the majority of users are NFS clients, and an application accessing the data uses a UNIX user as the service account.
  - `NTFS` if the file system is managed by a Microsoft Windows administrator, the majority of users are SMB clients, and an application accessing the data uses a Microsoft Windows user as the service account.
  - `MIXED` This is an advanced setting. For more information, see [Volume security style](https://docs.aws.amazon.com/fsx/latest/ONTAPGuide/volume-security-style.html) in the Amazon FSx for NetApp ONTAP User Guide.

- `svmAdminPassword`: string — Specifies the password to use when logging on to the SVM using a secure shell (SSH) connection to the SVM's management endpoint.

  Doing so enables you to manage the SVM using the NetApp ONTAP CLI or REST API. If you do not specify a password, you can still use the file system's `fsxadmin` user to manage the SVM. For more information, see [Managing SVMs using the NetApp ONTAP CLI](https://docs.aws.amazon.com/fsx/latest/ONTAPGuide/managing-resources-ontap-apps.html#vsadmin-ontap-cli) in the *FSx for ONTAP User Guide* .

- `tags`: [CfnTag](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of `Tag` values, with a maximum of 50 elements.

## Properties

- `activeDirectoryConfiguration`: [IResolvable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStorageVirtualMachine.ActiveDirectoryConfigurationProperty](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnStorageVirtualMachine.ActiveDirectoryConfigurationProperty.html) — Describes the Microsoft Active Directory configuration to which the SVM is joined, if applicable.

- `attrResourceArn`: string — Returns the storage virtual machine's Amazon Resource Name (ARN).

  Example: `arn:aws:fsx:us-east-2:111111111111:storage-virtual-machine/fs-0123456789abcdef1/svm-01234567890123456`

- `attrStorageVirtualMachineId`: string — Returns the storgage virtual machine's system generated ID.

  Example: `svm-0123456789abcedf1`

- `attrUuid`: string — Returns the storage virtual machine's system generated unique identifier (UUID).

  Example: `abcd0123-cd45-ef67-11aa-1111aaaa23bc`

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `env`: [ResourceEnvironment](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `fileSystemId`: string — Specifies the FSx for ONTAP file system on which to create the SVM.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `name`: string — The name of the SVM.

- `node`: [Node](https://docs.aws.amazon.com/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `rootVolumeSecurityStyle`: string — The security style of the root volume of the SVM.

  Specify one of the following values:.

- `stack`: [Stack](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `storageVirtualMachineRef`: [StorageVirtualMachineReference](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_fsx.StorageVirtualMachineReference.html) — A reference to a StorageVirtualMachine resource.

- `svmAdminPassword`: string — Specifies the password to use when logging on to the SVM using a secure shell (SSH) connection to the SVM's management endpoint.

- `tags`: [TagManager](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of `Tag` values, with a maximum of 50 elements.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isCfnStorageVirtualMachine(x: any): boolean` (static) — Checks whether the given object is a CfnStorageVirtualMachine.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
